unit uServer1; { mk, 13.7.05  }

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Winsock, WSocket, StdCtrls;

type
  TClientForm = class(TForm) mEin: TMemo;
    eAdresse: TEdit; ePort: TEdit; lAdresse: TLabel; lPort: TLabel;
    lEin: TLabel; mMeldungen: TMemo;
    lMeldungen: TLabel;
    procedure DataAvailable(Sender: TObject; Error: Word);
    procedure SessionAvailable(Sender: TObject; Error: Word);
    procedure SessionClosed(Sender: TObject; Error: Word);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  public
    empf : TWSocket;
    verb : array of TWSocket;
  end;

var
  ClientForm: TClientForm;

implementation

{$R *.DFM}

procedure TClientForm.FormCreate(Sender: TObject);
begin
  // Erzeugung, empf nimmt Verbindungen entgegen
  empf := TWSocket.Create(nil);
  empf.Addr   := eAdresse.Text;
  empf.Proto  := 'tcp';
  empf.Port   := ePort.Text;
  empf.Listen;              // versuche, Verbindung aufzubauen
  // nach dem effektiven Aufbau wird OnSessionConnected ausgelst
  // Verbinden der Ereignis-Behandlungen
  empf.OnSessionAvailable := SessionAvailable;
  empf.OnSessionClosed := SessionClosed;
end;

procedure TClientForm.FormDestroy(Sender: TObject);
var
  i,n : byte;
begin
  empf.Free;
  n := Length(verb);
  for i := 0 to n-1 do verb[i].Free;
end;

// Ereignis-Behandlung
procedure TClientForm.SessionAvailable(Sender: TObject; Error: Word);
var
  SocketHandle : TSocket;
  n            : byte;
begin
  if Error <> 0
  then
    mMeldungen.Lines.Add('keine Verbindung, Fehlernummer: ' + IntToStr(Error))
  else
    mMeldungen.Lines.Add('Verbindung steht! Port: '+empf.GetXPort);
  SocketHandle := empf.Accept;
  n := Length(verb); SetLength(verb,n+1);
  verb[n] := TWSocket.Create(nil);
  verb[n].Dup(SocketHandle);
  verb[n].SendStr('Hallo Client'+IntToStr(n)+'!');
  verb[n].OnDataAvailable := DataAvailable;
end;

// Ereignis-Behandlung
procedure TClientForm.DataAvailable(Sender: TObject; Error: Word);
var
  n,i,akt : byte;
  hs      : string;
begin
  n := Length(verb);
  for i := 0 to n-1 do
    if Sender = verb[i] then akt := i;
  hs := IntToStr(akt)+'>'+verb[akt].ReceiveStr;
  mEin.Lines.Add(hs);
  for i := 0 to n-1 do verb[i].SendStr(hs);
end;

// Ereignis-Behandlung
procedure TClientForm.SessionClosed(Sender: TObject; Error: Word);
begin
    if Error <> 0
    then
      mMeldungen.Lines.Add('Verbindung beendet, Fehlernummer: ' + IntToStr(Error))
    else
      mMeldungen.Lines.Add('Verbindung beendet!');
end;

end.

